#include "main.h"

int proc_rank, proc_size;

int main(int argc, char *argv[]) {
    int level_required = MPI_THREAD_MULTIPLE, level_provided;
    (MPI_Init_thread(&argc, &argv, level_required, &level_provided));
    assert(level_provided == level_required);
    MPI_Comm_rank(MPI_COMM_WORLD, &proc_rank);
    MPI_Comm_size(MPI_COMM_WORLD, &proc_size);
    srand(time(NULL) + proc_rank * 5);

    TaskList tasks;
    EO(proc_rank);
    for(int iteration = 0; iteration < ITERATION_COUNT; iteration++) {
        usleep(proc_rank * 133 * 1000);
        if(!proc_rank) puts("---");
        tasks.initRandomTasks();
        pthread_t tcalc, tmanage;
        pthread_create(&tcalc, NULL, start_thread_calc, (void*)&tasks);
        pthread_create(&tmanage, NULL, start_thread_manage, (void*)&tasks);

        pthread_join(tcalc, NULL);
        MPI_Barrier(MPI_COMM_WORLD);
        E(proc_rank); Eo("wtf?");
        int op = OP_END;
        MPI_Send(&op, 1, MPI_INT, proc_rank, MSG_REQUEST_TAG, MPI_COMM_WORLD);
        EO("!!!");
        pthread_join(tmanage, NULL);
        MPI_Barrier(MPI_COMM_WORLD);
    }

    MPI_Finalize();
    return 0;
}
