#include "task_list.h"

TaskList::TaskList() {
    pthread_mutex_init(&lock, NULL);
}

TaskList::~TaskList() {
    pthread_mutex_destroy(&lock);
}

void TaskList::initRandomTasks() {
    pthread_mutex_lock(&lock);
    tasks.clear();
    for(int i = 0; i < START_TASKS_COUNT; i++)
        tasks.push_back(Task(proc_rank, i, rand() % 5 + 1));
    reverse(tasks.begin(), tasks.end());
    pthread_mutex_unlock(&lock);
}

Task TaskList::getTask() {
    Task res = INVALID_TASK;
    pthread_mutex_lock(&lock);
    if(!tasks.empty()) {
        res = tasks.back();
        tasks.pop_back();
    }
    pthread_mutex_unlock(&lock);
    return res;
}
