#pragma once
#include "common.h"

struct Task {
    int init_thread_id;
    int task_number;
    int execution_time;

    Task(int a, int b, int c) : init_thread_id(a), task_number(b), execution_time(c) {}

    bool isValid() {
        return init_thread_id >= 0;
    }

    bool operator<(const Task& o) const {
        if(execution_time != o.execution_time)
            return execution_time < o.execution_time;
        return false;
    }
};
const Task INVALID_TASK = Task(-1, -1, -1);

class TaskList {
    vector<Task> tasks;
    pthread_mutex_t lock;

    TaskList(const TaskList& );
    TaskList& operator=(const TaskList& );

    public:
    TaskList();
    ~TaskList();

    void initRandomTasks();
    Task getTask();
};
