#include "thread_manage.h"

void* start_thread_manage(void *arg) {
    TaskList& tasks = *((TaskList*)(arg));
    int op_number;
    MPI_Status status;
    while(true) {
        MPI_Recv(&op_number, 1, MPI_INT, MPI_ANY_SOURCE, MSG_REQUEST_TAG, MPI_COMM_WORLD, &status);
        E(proc_rank); Eo(op_number);
        if(op_number == OP_END) break;
        assert(op_number == OP_REQUEST);
        Task next_task = tasks.getTask();
        E(proc_rank); Eo(next_task.isValid());
        if(!next_task.isValid()) {
            op_number = OP_TASK_NO;
            MPI_Send(&op_number, 1, MPI_INT, status.MPI_SOURCE, MSG_RESPONSE_TAG, MPI_COMM_WORLD);
        } else {
            op_number = OP_TASK_YES;
            MPI_Send(&op_number, 1, MPI_INT, status.MPI_SOURCE, MSG_RESPONSE_TAG, MPI_COMM_WORLD);
            int taskarr[3] = {next_task.init_thread_id, next_task.task_number, next_task.execution_time};
            MPI_Send(taskarr, 3, MPI_INT, status.MPI_SOURCE, MSG_TRANSFER_TAG, MPI_COMM_WORLD);
        }
    }
    return NULL;
}
